//////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2003, The Institute for Genomic Research (TIGR), Rockville,
// Maryland, U.S.A.  All rights reserved.
//////////////////////////////////////////////////////////////////////////////
EvScores& RegionPrediction::getScores(dsu::Strand_t strnd) { 
  int idx = getIdx(strnd);
  return _score[idx];
}

const EvScores& RegionPrediction::getScores(dsu::Strand_t strnd) const { 
  int idx = getIdx(strnd);
  return _score[idx];
}

const AnnotationScore& RegionPrediction::getScore(unsigned i, dsu::Strand_t strnd) const { 
  int idx = getIdx(strnd);
  const EvScores& scores = _score[idx];
  assert(i < EvScores::eNumBnd);
  return scores[i];
}


int RegionPrediction::getIdx(dsu::Strand_t strnd) const {
  assert(strnd == dsu::eNeg || strnd == dsu::ePos );
  int intStrnd = static_cast<int>(strnd);
  return intStrnd;
}
